Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Rice Pastry API
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## rice.p2p.aggregation
Class AggregationImpl

    java.lang.Object
      rice.p2p.aggregation.AggregationImpl

All Implemented Interfaces:
  Aggregation, Application, DebugCommandHandler, GCPast, Past, VersioningPast

public class AggregationImpl
extends java.lang.Object
implements Past, GCPast, VersioningPast, Aggregation, Application, DebugCommandHandler

DESCRIBE THE CLASS

Version:
  $Id: pretty.settings,v 1.3 2005/03/11 20:22:33 jeffh Exp $
Author:
  jeffh

Field Summary
`protected AggregateList` | `aggregateList` DESCRIBE THE FIELD
`protected Past` | `aggregateStore` DESCRIBE THE FIELD
`protected java.lang.String` | `debugID` DESCRIBE THE FIELD
`protected Endpoint` | `endpoint` DESCRIBE THE FIELD
`protected IdFactory` | `factory` DESCRIBE THE FIELD
`protected Continuation` | `flushWait` DESCRIBE THE FIELD
`protected java.lang.String` | `instance` DESCRIBE THE FIELD
`protected java.util.Vector` | `monitorIDs` DESCRIBE THE FIELD
`protected Node` | `node` DESCRIBE THE FIELD
`protected Past` | `objectStore` DESCRIBE THE FIELD
`protected AggregationPolicy` | `policy` DESCRIBE THE FIELD
`protected java.util.Random` | `random` DESCRIBE THE FIELD
`protected boolean` | `rebuildInProgress` DESCRIBE THE FIELD
`protected AggregationStatistics` | `stats` DESCRIBE THE FIELD
`protected java.util.Hashtable` | `timers` DESCRIBE THE FIELD
`static boolean` | `verbose` DESCRIBE THE FIELD
`protected StorageManager` | `waitingList` DESCRIBE THE FIELD

Fields inherited from interface rice.p2p.past.gc.GCPast
`INFINITY_EXPIRATION, NO_EXPIRATION_SPECIFIED`

Constructor Summary
`AggregationImpl(Node node, Past aggregateStore, Past objectStore, StorageManager waitingList, java.lang.String configFileName, IdFactory factory, java.lang.String instance)` Constructor for AggregationImpl.
`AggregationImpl(Node node, Past aggregateStore, Past objectStore, StorageManager waitingList, java.lang.String configFileName, IdFactory factory, java.lang.String instance, AggregationPolicy policy)` Constructor for AggregationImpl.

Method Summary
`void` | `deliver(Id id, Message message)` DESCRIBE THE METHOD
`void` | `fetch(PastContentHandle handle, Continuation command)` DESCRIBE THE METHOD
`void` | `flush(Continuation command)` DESCRIBE THE METHOD
`void` | `flush(Id id, Continuation command)` DESCRIBE THE METHOD
`boolean` | `forward(RouteMessage message)` DESCRIBE THE METHOD
`Past` | `getAggregateStore()` Gets the AggregateStore attribute of the AggregationImpl object
`java.io.Serializable` | `getHandle()` Gets the Handle attribute of the AggregationImpl object
`NodeHandle` | `getLocalNodeHandle()` Gets the LocalNodeHandle attribute of the AggregationImpl object
`int` | `getNumObjectsWaiting()` Gets the NumObjectsWaiting attribute of the AggregationImpl object
`Past` | `getObjectStore()` Gets the ObjectStore attribute of the AggregationImpl object
`int` | `getReplicationFactor()` Gets the ReplicationFactor attribute of the AggregationImpl object
`AggregationStatistics` | `getStatistics()` Gets the Statistics attribute of the AggregationImpl object
`java.lang.String` | `handleDebugCommand(java.lang.String command)` DESCRIBE THE METHOD
`void` | `insert(PastContent obj, Continuation command)` DESCRIBE THE METHOD
`void` | `insert(PastContent obj, long lifetime, Continuation command)` DESCRIBE THE METHOD
`void` | `lookup(Id id, boolean cache, Continuation command)` DESCRIBE THE METHOD
`void` | `lookup(Id id, Continuation command)` DESCRIBE THE METHOD
`void` | `lookup(Id id, long version, Continuation command)` DESCRIBE THE METHOD
`void` | `lookupHandle(Id id, NodeHandle handle, Continuation command)` DESCRIBE THE METHOD
`void` | `lookupHandles(Id id, int max, Continuation command)` DESCRIBE THE METHOD
`void` | `lookupHandles(Id id, long version, int max, Continuation command)` DESCRIBE THE METHOD
`void` | `refresh(Id[] ids, long[] expirations, Continuation command)` DESCRIBE THE METHOD
`void` | `refresh(Id[] ids, long[] versions, long[] expirations, Continuation command)` DESCRIBE THE METHOD
`void` | `refresh(Id[] ids, long expiration, Continuation command)` DESCRIBE THE METHOD
`void` | `reset(Continuation command)` DESCRIBE THE METHOD
`void` | `rollback(Id id, Continuation command)` DESCRIBE THE METHOD
`void` | `setConsolidationInterval(long consolidationIntervalSec)` Sets the ConsolidationInterval attribute of the AggregationImpl object
`void` | `setConsolidationMinObjectsPerAggregate(int minObjectsInAggregateArg)` Sets the ConsolidationMinObjectsPerAggregate attribute of the AggregationImpl object
`void` | `setConsolidationMinUtilization(double minUtilization)` Sets the ConsolidationMinUtilization attribute of the AggregationImpl object
`void` | `setConsolidationThreshold(long consolidationThresholdSec)` Sets the ConsolidationThreshold attribute of the AggregationImpl object
`void` | `setFlushInterval(int flushIntervalSec)` Sets the FlushInterval attribute of the AggregationImpl object
`void` | `setHandle(java.io.Serializable handle, Continuation command)` Sets the Handle attribute of the AggregationImpl object
`void` | `setLogLevel(int newLevel)` Sets the LogLevel attribute of the AggregationImpl object
`void` | `setMaxAggregateSize(int maxAggregateSize)` Sets the MaxAggregateSize attribute of the AggregationImpl object
`void` | `setMaxObjectsInAggregate(int maxObjectsInAggregate)` Sets the MaxObjectsInAggregate attribute of the AggregationImpl object
`void` | `setRenewThreshold(int expirationRenewThresholdHrs)` Sets the RenewThreshold attribute of the AggregationImpl object
`void` | `update(NodeHandle handle, boolean joined)` DESCRIBE THE METHOD

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### aggregateStore

    protected final Past aggregateStore

  DESCRIBE THE FIELD

### waitingList

    protected final StorageManager waitingList

  DESCRIBE THE FIELD

### policy

    protected final AggregationPolicy policy

  DESCRIBE THE FIELD

### aggregateList

    protected final AggregateList aggregateList

  DESCRIBE THE FIELD

### endpoint

    protected final Endpoint endpoint

  DESCRIBE THE FIELD

### objectStore

    protected final Past objectStore

  DESCRIBE THE FIELD

### instance

    protected final java.lang.String instance

  DESCRIBE THE FIELD

### factory

    protected final IdFactory factory

  DESCRIBE THE FIELD

### debugID

    protected final java.lang.String debugID

  DESCRIBE THE FIELD

### random

    protected final java.util.Random random

  DESCRIBE THE FIELD

### node

    protected final Node node

  DESCRIBE THE FIELD

### timers

    protected java.util.Hashtable timers

  DESCRIBE THE FIELD

### flushWait

    protected Continuation flushWait

  DESCRIBE THE FIELD

### rebuildInProgress

    protected boolean rebuildInProgress

  DESCRIBE THE FIELD

### monitorIDs

    protected java.util.Vector monitorIDs

  DESCRIBE THE FIELD

### stats

    protected AggregationStatistics stats

  DESCRIBE THE FIELD

### verbose

    public static final boolean verbose

  DESCRIBE THE FIELD

  See Also:
    Constant Field Values

Constructor Detail

### AggregationImpl

    public AggregationImpl(Node node,
                           Past aggregateStore,
                           Past objectStore,
                           StorageManager waitingList,
                           java.lang.String configFileName,
                           IdFactory factory,
                           java.lang.String instance)
                    throws java.io.IOException

  Constructor for AggregationImpl.

Parameters:
  `node` - DESCRIBE THE PARAMETER
  `aggregateStore` - DESCRIBE THE PARAMETER
  `objectStore` - DESCRIBE THE PARAMETER
  `waitingList` - DESCRIBE THE PARAMETER
  `configFileName` - DESCRIBE THE PARAMETER
  `factory` - DESCRIBE THE PARAMETER
  `instance` - DESCRIBE THE PARAMETER
Throws:
  `java.io.IOException` - DESCRIBE THE EXCEPTION

### AggregationImpl

    public AggregationImpl(Node node,
                           Past aggregateStore,
                           Past objectStore,
                           StorageManager waitingList,
                           java.lang.String configFileName,
                           IdFactory factory,
                           java.lang.String instance,
                           AggregationPolicy policy)
                    throws java.io.IOException

  Constructor for AggregationImpl.

Parameters:
  `node` - DESCRIBE THE PARAMETER
  `aggregateStore` - DESCRIBE THE PARAMETER
  `objectStore` - DESCRIBE THE PARAMETER
  `waitingList` - DESCRIBE THE PARAMETER
  `configFileName` - DESCRIBE THE PARAMETER
  `factory` - DESCRIBE THE PARAMETER
  `instance` - DESCRIBE THE PARAMETER
  `policy` - DESCRIBE THE PARAMETER
Throws:
  `java.io.IOException` - DESCRIBE THE EXCEPTION

Method Detail

### getHandle

    public java.io.Serializable getHandle()

  Gets the Handle attribute of the AggregationImpl object

  Specified by:
    `getHandle` in interface `Aggregation`
  Returns:
    The Handle value

### getLocalNodeHandle

    public NodeHandle getLocalNodeHandle()

  Gets the LocalNodeHandle attribute of the AggregationImpl object

  Specified by:
    `getLocalNodeHandle` in interface `Past`
  Returns:
    The LocalNodeHandle value

### getReplicationFactor

    public int getReplicationFactor()

  Gets the ReplicationFactor attribute of the AggregationImpl object

  Specified by:
    `getReplicationFactor` in interface `Past`
  Returns:
    The ReplicationFactor value

### getAggregateStore

    public Past getAggregateStore()

  Gets the AggregateStore attribute of the AggregationImpl object

  Returns:
    The AggregateStore value

### getObjectStore

    public Past getObjectStore()

  Gets the ObjectStore attribute of the AggregationImpl object

  Returns:
    The ObjectStore value

### getNumObjectsWaiting

    public int getNumObjectsWaiting()

  Gets the NumObjectsWaiting attribute of the AggregationImpl object

  Returns:
    The NumObjectsWaiting value

### getStatistics

    public AggregationStatistics getStatistics()

  Gets the Statistics attribute of the AggregationImpl object

  Returns:
    The Statistics value

### setHandle

    public void setHandle(java.io.Serializable handle,
                          Continuation command)

  Sets the Handle attribute of the AggregationImpl object

  Specified by:
    `setHandle` in interface `Aggregation`
  Parameters:
    `handle` - The new Handle value
    `command` - The new Handle value

### setFlushInterval

    public void setFlushInterval(int flushIntervalSec)

  Sets the FlushInterval attribute of the AggregationImpl object

  Parameters:
    `flushIntervalSec` - The new FlushInterval value

### setMaxAggregateSize

    public void setMaxAggregateSize(int maxAggregateSize)

  Sets the MaxAggregateSize attribute of the AggregationImpl object

  Parameters:
    `maxAggregateSize` - The new MaxAggregateSize value

### setMaxObjectsInAggregate

    public void setMaxObjectsInAggregate(int maxObjectsInAggregate)

  Sets the MaxObjectsInAggregate attribute of the AggregationImpl object

  Parameters:
    `maxObjectsInAggregate` - The new MaxObjectsInAggregate value

### setRenewThreshold

    public void setRenewThreshold(int expirationRenewThresholdHrs)

  Sets the RenewThreshold attribute of the AggregationImpl object

  Parameters:
    `expirationRenewThresholdHrs` - The new RenewThreshold value

### setConsolidationInterval

    public void setConsolidationInterval(long consolidationIntervalSec)

  Sets the ConsolidationInterval attribute of the AggregationImpl object

  Parameters:
    `consolidationIntervalSec` - The new ConsolidationInterval value

### setConsolidationThreshold

    public void setConsolidationThreshold(long consolidationThresholdSec)

  Sets the ConsolidationThreshold attribute of the AggregationImpl object

  Parameters:
    `consolidationThresholdSec` - The new ConsolidationThreshold value

### setConsolidationMinObjectsPerAggregate

    public void setConsolidationMinObjectsPerAggregate(int minObjectsInAggregateArg)

  Sets the ConsolidationMinObjectsPerAggregate attribute of the AggregationImpl object

  Parameters:
    `minObjectsInAggregateArg` - The new ConsolidationMinObjectsPerAggregate value

### setConsolidationMinUtilization

    public void setConsolidationMinUtilization(double minUtilization)

  Sets the ConsolidationMinUtilization attribute of the AggregationImpl object

  Parameters:
    `minUtilization` - The new ConsolidationMinUtilization value

### setLogLevel

    public void setLogLevel(int newLevel)

  Sets the LogLevel attribute of the AggregationImpl object

  Parameters:
    `newLevel` - The new LogLevel value

### handleDebugCommand

    public java.lang.String handleDebugCommand(java.lang.String command)

  DESCRIBE THE METHOD

  Specified by:
    `handleDebugCommand` in interface `DebugCommandHandler`
  Parameters:
    `command` - DESCRIBE THE PARAMETER
  Returns:
    DESCRIBE THE RETURN VALUE

### refresh

    public void refresh(Id[] ids,
                        long expiration,
                        Continuation command)

  DESCRIBE THE METHOD

  Specified by:
    `refresh` in interface `GCPast`
  Parameters:
    `ids` - DESCRIBE THE PARAMETER
    `expiration` - DESCRIBE THE PARAMETER
    `command` - DESCRIBE THE PARAMETER

### refresh

    public void refresh(Id[] ids,
                        long[] expirations,
                        Continuation command)

  DESCRIBE THE METHOD

  Specified by:
    `refresh` in interface `GCPast`
  Parameters:
    `ids` - DESCRIBE THE PARAMETER
    `expirations` - DESCRIBE THE PARAMETER
    `command` - DESCRIBE THE PARAMETER

### refresh

    public void refresh(Id[] ids,
                        long[] versions,
                        long[] expirations,
                        Continuation command)

  DESCRIBE THE METHOD

  Specified by:
    `refresh` in interface `VersioningPast`
  Parameters:
    `ids` - DESCRIBE THE PARAMETER
    `versions` - DESCRIBE THE PARAMETER
    `expirations` - DESCRIBE THE PARAMETER
    `command` - DESCRIBE THE PARAMETER

### insert

    public void insert(PastContent obj,
                       Continuation command)

  DESCRIBE THE METHOD

  Specified by:
    `insert` in interface `Past`
  Parameters:
    `obj` - DESCRIBE THE PARAMETER
    `command` - DESCRIBE THE PARAMETER

### insert

    public void insert(PastContent obj,
                       long lifetime,
                       Continuation command)

  DESCRIBE THE METHOD

  Specified by:
    `insert` in interface `GCPast`
  Parameters:
    `obj` - DESCRIBE THE PARAMETER
    `lifetime` - DESCRIBE THE PARAMETER
    `command` - DESCRIBE THE PARAMETER

### lookup

    public void lookup(Id id,
                       boolean cache,
                       Continuation command)

  DESCRIBE THE METHOD

  Specified by:
    `lookup` in interface `Past`
  Parameters:
    `id` - DESCRIBE THE PARAMETER
    `cache` - DESCRIBE THE PARAMETER
    `command` - DESCRIBE THE PARAMETER

### lookup

    public void lookup(Id id,
                       long version,
                       Continuation command)

  DESCRIBE THE METHOD

  Specified by:
    `lookup` in interface `VersioningPast`
  Parameters:
    `id` - DESCRIBE THE PARAMETER
    `version` - DESCRIBE THE PARAMETER
    `command` - DESCRIBE THE PARAMETER

### lookup

    public void lookup(Id id,
                       Continuation command)

  DESCRIBE THE METHOD

  Specified by:
    `lookup` in interface `Past`
  Parameters:
    `id` - DESCRIBE THE PARAMETER
    `command` - DESCRIBE THE PARAMETER

### lookupHandles

    public void lookupHandles(Id id,
                              long version,
                              int max,
                              Continuation command)

  DESCRIBE THE METHOD

  Specified by:
    `lookupHandles` in interface `VersioningPast`
  Parameters:
    `id` - DESCRIBE THE PARAMETER
    `version` - DESCRIBE THE PARAMETER
    `max` - DESCRIBE THE PARAMETER
    `command` - DESCRIBE THE PARAMETER

### lookupHandle

    public void lookupHandle(Id id,
                             NodeHandle handle,
                             Continuation command)

  DESCRIBE THE METHOD

  Specified by:
    `lookupHandle` in interface `Past`
  Parameters:
    `id` - DESCRIBE THE PARAMETER
    `handle` - DESCRIBE THE PARAMETER
    `command` - DESCRIBE THE PARAMETER

### lookupHandles

    public void lookupHandles(Id id,
                              int max,
                              Continuation command)

  DESCRIBE THE METHOD

  Specified by:
    `lookupHandles` in interface `Past`
  Parameters:
    `id` - DESCRIBE THE PARAMETER
    `max` - DESCRIBE THE PARAMETER
    `command` - DESCRIBE THE PARAMETER

### fetch

    public void fetch(PastContentHandle handle,
                      Continuation command)

  DESCRIBE THE METHOD

  Specified by:
    `fetch` in interface `Past`
  Parameters:
    `handle` - DESCRIBE THE PARAMETER
    `command` - DESCRIBE THE PARAMETER

### flush

    public void flush(Id id,
                      Continuation command)

  DESCRIBE THE METHOD

  Specified by:
    `flush` in interface `Aggregation`
  Parameters:
    `id` - DESCRIBE THE PARAMETER
    `command` - DESCRIBE THE PARAMETER

### flush

    public void flush(Continuation command)

  DESCRIBE THE METHOD

  Specified by:
    `flush` in interface `Aggregation`
  Parameters:
    `command` - DESCRIBE THE PARAMETER

### rollback

    public void rollback(Id id,
                         Continuation command)

  DESCRIBE THE METHOD

  Specified by:
    `rollback` in interface `Aggregation`
  Parameters:
    `id` - DESCRIBE THE PARAMETER
    `command` - DESCRIBE THE PARAMETER

### reset

    public void reset(Continuation command)

  DESCRIBE THE METHOD

  Specified by:
    `reset` in interface `Aggregation`
  Parameters:
    `command` - DESCRIBE THE PARAMETER

### forward

    public boolean forward(RouteMessage message)

  DESCRIBE THE METHOD

  Specified by:
    `forward` in interface `Application`
  Parameters:
    `message` - DESCRIBE THE PARAMETER
  Returns:
    DESCRIBE THE RETURN VALUE

### update

    public void update(NodeHandle handle,
                       boolean joined)

  DESCRIBE THE METHOD

  Specified by:
    `update` in interface `Application`
  Parameters:
    `handle` - DESCRIBE THE PARAMETER
    `joined` - DESCRIBE THE PARAMETER

### deliver

    public void deliver(Id id,
                        Message message)

  DESCRIBE THE METHOD

  Specified by:
    `deliver` in interface `Application`
  Parameters:
    `id` - DESCRIBE THE PARAMETER
    `message` - DESCRIBE THE PARAMETER

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Rice Pastry API
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2005 - Rice Pastry.